function EFFECT:Init(data)
	
	self.WeaponEnt = data:GetEntity()
	self.Attachment = data:GetAttachment()
	
	self.Position = self:GetTracerShootPos(data:GetOrigin(), self.WeaponEnt, self.Attachment)
	self.Forward = data:GetNormal()
	self.Angle = self.Forward:Angle()
	self.Right = self.Angle:Right()
	self.Up = self.Angle:Up()
	
	local AddVel = self.WeaponEnt:GetOwner():GetVelocity()
	
	local emitter = ParticleEmitter(self.Position)
	for i = 1,4 do
		local particle = emitter:Add("particle/particle_smokegrenade", self.Position)
		particle:SetVelocity(60 * i * self.Forward + 1.1 * AddVel)
		particle:SetDieTime(math.Rand(0.78,1.78))
		particle:SetStartAlpha(math.Rand(150,200))
		particle:SetStartSize(math.random(3,4))
		particle:SetEndSize(math.Rand(28,35))
		particle:SetRoll(math.Rand(180,480))
		particle:SetRollDelta(math.Rand(-1,1))
		particle:SetColor(190,190,190)
		particle:SetLighting(true)
		particle:SetAirResistance(150)
    end
		
    if math.random( 1, 2 ) == 1 then

		for j = 1,2 do
			for i = -1,1,2 do 		
				local particle = emitter:Add( "effects/muzzleflash"..math.random( 1, 4 ), self.Position - 3 * self.Forward + 2 * j * i * self.Right)
				particle:SetVelocity( 30 * j * i * self.Right + AddVel )
				particle:SetGravity( AddVel )
				particle:SetDieTime( 0.1 )
				particle:SetStartAlpha( 150 )
				particle:SetEndAlpha( 0 )
				particle:SetStartSize( 0.3 * i )
				particle:SetEndSize( 10 )
				particle:SetRoll( math.Rand( 180, 480 ) )
				particle:SetRollDelta( math.Rand( -1, 1 ) )
				particle:SetColor( 255, 255, 255 )	
			end
		end	
		
		for i = 1,4 do
			for j = 1,2 do

				local particle = emitter:Add( "sprites/heatwave", self.Position - self.Forward * 4 )
				particle:SetVelocity( 40 * i * self.Forward + 20 * VectorRand() + 1.05 * AddVel )
				particle:SetGravity( Vector( 0, 0, 100 ) )
				particle:SetAirResistance( 90 )
				particle:SetDieTime( math.Rand( 0.2, 0.25 ) )
				particle:SetStartSize( math.random( 1, 3 ) )
				particle:SetEndSize( math.Rand( 12, 18 ) )
				particle:SetRoll( math.Rand( 180, 480 ) )
				particle:SetRollDelta( math.Rand( -1, 1 ) )

				local particle = emitter:Add("effects/muzzleflash"..math.random(1,4), self.Position - 3*self.Forward + 2*self.Right)
				particle:SetVelocity( 75 * i * self.Forward + 8 * VectorRand() + AddVel )
				particle:SetGravity(Vector(0,0,0))
				particle:SetDieTime(0.1)
				particle:SetStartAlpha(250)
				particle:SetStartSize(math.random(3,4) * i)
				particle:SetEndSize(math.random(10,15))
				particle:SetRoll(math.Rand(180,480))
				particle:SetRollDelta(math.Rand(-1,1))
				particle:SetColor(255,255,255)
			
				local dlight = DynamicLight(0)
				if (dlight) then
					dlight.Pos 		= self.Position
					dlight.r 		= 70
					dlight.g 		= 50
					dlight.b 		= 0
					dlight.Brightness = 3
					dlight.size 	= 600
					dlight.DieTime 	= CurTime() + 0.01
				end
	
			end
		end
	end
	emitter:Finish()
end

function EFFECT:Think()

	return false
end


function EFFECT:Render()
end